variables:
  DOCKER_FILE: Dockerfile
  DOCKER_TAG: latest
  DOCKER_IMAGE: ${CI_REGISTRY_IMAGE}

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID               # Execute jobs in merge request context
    - if: $CI_COMMIT_BRANCH == 'main'      # Execute jobs when a new commit is pushed to master branch

stages:
  - prepare
  - build

# Stage: prepare
##############################################################################

.prepare:docker: &prepare_docker
  stage: prepare
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [ "" ]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"username\":\"${CI_REGISTRY_USER}\",\"password\":\"${CI_REGISTRY_PASSWORD}\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context ${CI_PROJECT_DIR} --dockerfile ${CI_PROJECT_DIR}/${DOCKER_FILE} --destination ${DOCKER_IMAGE}:${DOCKER_TAG} --snapshotMode=redo --cache=true
  when: manual

prepare:docker:
  <<: *prepare_docker

build:linux:
  stage: build
  script:
    - export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:.
    - make
    - make test
  image: ${DOCKER_IMAGE}:${DOCKER_TAG}
  tags:
    - docker
